
// Section 5 - "Data Verification", Example 1
// The class-picking example with full data verification.  This example is tamper-proof, and
// disallows any illegal values to be accepted.

var/list/valid_classes = list("Soldier","Mage","Archer")

mob
  var/class

  Topic(href, list/href_list)
    // Is this the player who is supposed to receive the link?  The "who" check
    if(src != usr) return
    ..()

    var/action = href_list["action"]

    if(action == "classpick")
      var/newclass = href_list["value"]
      if(newclass)
        if(src.SelectClass(newclass))
          // only close the window when the class was successfully picked
          src << browse(null, "window=classpick")
        else
          // an invalid value was sent
          src << "Invalid."

  proc
    canChooseClass() // Am I able to choose classes?  The "when" check
      return !src.class

    isValidClass(cls) // Is this a valid class?  The "what" check
      return (cls in valid_classes)

    SelectClass(cls)
      // verify that the player can choose the class, and if it is a valid class to choose
      if(!canChooseClass() || !isValidClass(cls))
        return 0 // verification failed, do not use the data

      src << "You are now a [cls]!"
      src.class = cls
      return 1

  verb/choose_class()
    if(!src.canChooseClass()) // do the "when" check right before sending the browser form
      src << "You already have an assigned class!"
      return

    var/text = \
    {"
      What class would you like to pick? <br />
        - <a href=byond://?src=\ref[src]&action=classpick&value=Soldier>Soldier</a><br />
        - <a href=byond://?src=\ref[src]&action=classpick&value=Mage>Mage</a><br />
        - <a href=byond://?src=\ref[src]&action=classpick&value=Archer>Archer</a>
    "}

    src << browse(text, "window=classpick;size=500x300")

