
// Section 6 - "Organization", Example 1
// A closable form that tells the user "Hello World!".  Demonstrates the
// basic usage of form datums.

helloWorldForm
  var
    client/owner // the viewer of the form
    self

  New(client/_owner)
    ..()
    self = src // to prevent the garbage collector from deleting the unreferenced form
    src.owner = _owner
    src.DisplayPage() // display the page once it's created

  Del()
    // close the window when the form is deleted
    owner << browse(null, "window=helloworld")
    ..()

  Topic(href, list/href_list)
    ..()

    if(href_list["action"] == "close")
      del(src) // delete the form when the close link is clicked on

  proc
    DisplayPage()
      // generate the text
      var/text = {"
        <html>
        <head> <title> Hello World </title> </head>
        <body>
          Hello World!<br />
          <br />
          <a href="byond://?src=\ref[src]&action=close">\[Close\]</a>
        </body>
        </html>
      "}

      // then display the page to the owner
      owner << browse(text, "window=helloworld;titlebar=0")

mob/verb/hello_world()
  // create a new instance of the hello world form datum to handle all
  // form functions
  new /helloWorldForm (src.client)
