
// Section 6 - "Organization", Example 2
// Example 4.3 rewritten by using a form datum.  Forms are kept track of through
// a mob variable holding the currently viewed form.

infoForm
  var
    client/owner

  New(client/_owner)
    ..()
    src.owner = _owner
    src.DisplayForm()

  Del()
    owner << browse(null, "window=infoform")
    ..()

  Topic(href, list/href_list)
    ..()

    if(href_list["form"]) // determine if the link is a form if the "form" param was sent
      var/list/data = href_list.Copy(href_list.Find("form") + 1) // split the 'src' parameter
      ProcessForm(href_list["form"], data) // process data
      DisplayData()
      // close the form when submitted
      del(src)

  proc
    DisplayForm()
      var/html = \
      {"
        <form name="settings" action="byond://" method="get">
          <input type="hidden" name="src" value="\ref[src]" />
          <input type="hidden" name="form" value="settings" />

          Name: <input type="text" name="name" value="[owner.mob.name]" /> <br />
          Age: <input type="text" name="age" value="[owner.mob.age]" /> <br />
          Gender: <select name="gender">
                    <option value="male">Male</option>
                    <option value="female">Female</option>
                    <option value="neuter">Neuter</option>
                  </select> <br />
          <input type="submit" value="Submit" />
          <input type="reset" value="Reset" />
        </form>
      "}

      owner << browse(html, "window=infoform;size=500x300")

    ProcessForm(formname, list/params)
      for(var/item in params) // loop through each name=value item individually
        ProcessVariable(formname, item, params[item])

    ProcessVariable(formname, name, value)
      var/mob/M = owner.mob
      if(formname == "settings")
        switch(name)
          if("name")
            M.name = value
          if("age")
            M.age = text2num(value)
          if("gender")
            M.gender = value

    DisplayData()
      var/mob/M = owner.mob
      owner << "My name is [M.name]."
      owner << "I am [M.age] years old."
      owner << "I am [M.gender]"

mob
  var
    age = 20
    infoForm/form

  verb
    settings()
      if(src.form) return // don't let another form be opened if one is already present
      src.form = new /infoForm (src.client)
