
// Section 6 - "Organization", Example 7
// Rewriting our settings form by using our updated generic form

#include "S6E06.dm" // include definition for Generic Form V2

genericForm/settings
  window_name = "Settings"
  window_params = "size=500x300&titlebar=0"

  GeneratePage(list/errors=list())
    var/mob/M = src.owner.mob
    var/text = {"
    <form name="settings" action="byond://" method="get">
      <input type="hidden" name="src" value="\ref[src]" />
      <input type="hidden" name="form" value="settings" />

      Name: <input type="text" name="name" value="[M.name]" size="25"/> <span class="error">[errors["name"]]</span><br />
      Age: <input type="text" name="age" value="[M.age]" size="3" /> <span class="error">[errors["age"]]</span> <br />
      Description: (up to 300 characters) <span class="error">[errors["desc"]]</span> <br />
      <textarea name="desc" rows="5" cols="30" size="300">[M.desc]</textarea> <br />

      <input type="submit" value="Submit" />
    </form>
    "}

    UpdatePage(text, "span.error { font-size: 8pt; color: #ff0000 }")

  ProcessVariable(formname, name, value)
    var/mob/M = owner.mob
    if(formname == "settings")
      switch(name)
        if("name")
          M.name = value
          if(!M.isValidName(value))
            return "Your name must be between 3 and 25 characters long"
        if("age")
          value = text2num(value)
          M.age = value
          if(!M.isValidAge(value))
            return "Invalid age"
        if("desc")
          M.desc = value
          if(!M.isValidDesc(value))
            return "Your description is too long";
    return null

  FormSubmitSuccess(formname)
    del(src) // close form when successfully submitted

mob
  name = "John Doe"
  desc = "I'm just the average joe."
  var/age = 20

  proc
    isValidName(text)
      return length(text) <= 25 && length(text) >= 3

    isValidAge(age)
      return age > 0 && age == round(age)

    isValidDesc(text)
      return length(text) <= 300

  verb/settings()
    if(src.form) return
    src.form = new /genericForm/settings (src.client)