
// Section 6 - "Organization", Example 9
// An extention of Generic Form V2 that implements a timer, and functions
// relating to it

#include "S6E06.dm" // include definition for Generic Form V2

genericForm/timed
  var
    time_left = -1
    tick_interval = 10
    update = 0

  New(client/_owner)
    // Start the timer if a time has been defined to the
    // timed form at compile-time
    if(time_left > 0)
      spawn() StartTimer(time_left)
    ..()

  proc
    StartTimer(time)
      // timer has started
      time_left = time
      TimeStarted(time)

      while(time_left > 0)
        sleep(tick_interval)
        time_left -= tick_interval
        // if specified, a timed form can update every tick interval
        if(update) DisplayPage()

      TimeUp() // bzzt, time's up!

    TimeStarted(time)
      // Called on the event the timer has started
      // Free to be implemented in children types

    TimeUp()
      // Called when the time has reached 0
      // Form by default closes at this point, so delete the form
      del(src)

