
// Section 6 - "Organization", Example 10
// An exploding letter form that uses the timed form extention we defined
// earlier

#include "S6E09.dm" // include definition for Generic Form Timer
#include "S6E08.dm" // include definition for the alert form

genericForm/timed/explodingLetter
  window_name = "Mysterious Letter"
  window_params = "size=300x200&can_close=0&can_resize=0&can_minimize=0"
  time_left = 100 // The letter explodes in 100 ticks (or 10 seconds)
  update = 1 // let the page be refreshed every second (time_interval is 10)

  Topic(href, list/href_list)
    . = ..()
    if(.)
      if(href_list["action"] == "dispose" && time_left > 0)
        var/message = "You have disposed of the paper and are spared of your life."
        new /genericForm/alert (src.owner, message)
        del(src)

  GeneratePage()
    var/text
    var/style = "body { text-align: center }"
    if(src.time_left <= 0)
      text = "<span class=\"exploded\">BOOM!</span>"
      style += "span.exploded { font-size: 36pt; color: #ff0000 }"
    else
      text = {"
        <i>Top Secret: The hidden treasure is located in locker 101.</i> <br />
        <br />
        This letter will explode in [src.time_left / 10] second\s. <br />
        <br />
        You may want to <a href="byond://?src=\ref[src]&action=dispose">dispose</a>
        of the letter before it explodes in your hand.
      "}

    UpdatePage(text, style)

  TimeUp()
    // 2 seconds after the letter explodes, close the form
    spawn(20)
      var/message = "The explosive letter detonates in your hand, and you are killed in the blast."
      new /genericForm/alert (src.owner, message)
      ..()

mob/verb/read_secret_letter()
  if(src.form) return
  src.form = new /genericForm/timed/explodingLetter (src.client)